/**
 * @file : debughandle.h
 * @description : Win32 API debuging handler
 *
 * xSCommander
 *
 * Copyright (C) 2003 Jung Jae Sung <aspilla2@korea.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#if !defined(_DEBUGHANDLE_H)
#define _DEBUGHANDLE_H

#if defined(_DEBUG)
#if !defined(DEBUG)
#define DEBUG
#endif //#if defined(_DEBUG)

#if defined(DEBUG)
#if !defined(_DEBUG)
#define(_DEBUG)
#endif //#if defined(DEBUG)

#if defined(TRACE)
#undef TRACE
#endif //#if defined(TRACE)

#if defined(TRACE0)
#undef TRACE0
#endif //#if defined(TRACE0)

#if defined(TRACE1)
#undef TRACE1
#endif //#if defined(TRACE1)

#if defined(TRACE2)
#undef TRACE2
#endif //#if defined(TRACE2)

#if defined(TRACE3)
#undef TRACE3
#endif //#if defined(TRACE3)

#if defined(TRACE4)
#undef TRACE4
#endif //#if defined(TRACE4)

#if defined(_DEBUG)
#include <crtdbg.h>		// For _RPT, _ASSERT

/**************************************************************************/
/** @macro : TRACE		                                                  */
/**************************************************************************/

#define TRACE						TRACE0
#define TRACE0(x0)					_CrtSetReportMode(_CRT_WARN, _CRTDBG_MODE_DEBUG);		\	// Print on debug window
									_RPTF0(_CRT_WARN, x0)										// Print tracing message

#define TRACE1(x0, x1)				_CrtSetReportMode(_CRT_WARN, _CRTDBG_MODE_DEBUG);		\	// Print on debug window
									_RPTF1(_CRT_WARN, x0, x1)									// Print tracing message

#define TRACE2(x0, x1, x2)			_CrtSetReportMode(_CRT_WARN, _CRTDBG_MODE_DEBUG);		\	// Print on debug window
									_RPTF2(_CRT_WARN, x0, x1, x2)								// Print tracing message

#define TRACE3(x0, x1, x2, x3)		_CrtSetReportMode(_CRT_WARN, _CRTDBG_MODE_DEBUG);		\	// Print on debug window
									_RPTF3(_CRT_WARN, x0, x1, x2, x3)							// Print tracing message
                        
#define TRACE4(x0, x1, x2, x3, x4)	_CrtSetReportMode(_CRT_WARN, _CRTDBG_MODE_DEBUG);		\	// Print on debug window
									_RPTF4(_CRT_WARN, x0, x1, x2, x3, x4)						// Print tracing message

/**************************************************************************/
/** @macro : ASSERT			                                              */
/**************************************************************************/

#define ASSERT						_ASSERTE

#else //#if defined(_DEBUG)

#define TRACE						// Do nothing
#define TRACE0						// Do nothing
#define TRACE1						// Do nothing
#define TRACE2						// Do nothing
#define TRACE3						// Do nothing
#define TRACE4						// Do nothing

#define ASSERT						// Do nothing

#endif //#if defined(_DEBUG)
#endif //#if !defined(_DEBUGHANDLE_H)
